# encoding: utf-8
import json
import pickle
import os

business_path = "data/business.json"
save_id2business_path = "model/id2business.pkl"

def load_id2business():
    id2business = None
    if not os.path.exists(save_id2business_path):
        id2business = dict()
        with open(business_path,"r",encoding="utf-8") as f:
            for line in f.readlines():
                if len(line.strip()) == 0:
                    continue
                ele = json.loads(line.strip())
                business_id = ele["business_id"]
                if ele["business_id"] in id2business:
                    print("{} duplicated".format(str(business_id)))
                    continue
                id2business[business_id] = ele
                
        with open(save_id2business_path,'wb') as f:
            pickle.dump(id2business,f)

    else: 
        with open(save_id2business_path,'rb') as f:
            id2business = pickle.load(f)
    return id2business


id2business = load_id2business()