# encoding: utf-8
import pandas as pd
import json
from business import Business
import time

def get_review_summary_for_business(biz_id,review_df):
	# 获取每一个business的评论总结
	business = Business(review_df)
	return business.aspect_based_summary()

def main(): 
	review_path = "data/review.json"
	reviews = []
	with open(review_path,"r",encoding="utf-8") as f:
		for line in f.readlines():
			if len(line.strip()) == 0:
				continue
			ele = json.loads(line.strip())
			reviews.append(ele)
	review_df = pd.DataFrame(reviews)
	print(len(review_df))
	print(review_df.head())
	
	bus_ids = ["4JNXUYY8wbaaDmk3BPzlWw"]  # 指定几个business ids

	for bus_id in bus_ids:
		print ("Working on biz_id %s" % bus_id)
		start = time.time()

		summary = get_review_summary_for_business(bus_id,review_df[review_df.business_id==bus_id])
		
		# format and print....
		print(summary)
		print("--------------------------------------------------------")

if __name__ == "__main__":
	main()


